;
; AutoIt Version: 3.0
; Language:       English
; Platform:       Win9x/NT
; Author: Jos van der Zande
; Email : jdeb@autoitscript.com
;
; Script Function:
; Store this script in the Helpfile directory where the project file is stored.
; It assumes that the Include directory is a subdir of directory defined in the registry key: "HKEY_LOCAL_MACHINE\SOFTWARE\AutoIt v3\AutoIt","Installdir"
; It will read all *.au3 files in this include directory and create the \html\libfunctions.htm.
; It wil also create one description file per ???.au3 it finds. this will be stored in \html\libfunctions\????.htm.
; All descriptions which are specified in the ???.AU3 are copied into this description htm file and
; references are created to these in the \html\libfunctions.htm.
; ******************************************************
; Read all Include functions and generate helpfile
; ******************************************************
; remove old file that contains a list of userfunctions
; Generate the index File

#include "..\..\_build\include\OutputLib.au3"
#include <Constants.au3>

Opt("TrayIconDebug", 1)

OnAutoItExitRegister("OnQuit") ; ### when run in standalone
_OutputWindowCreate() ; ### when run in standalone

FileChangeDir(@ScriptDir)

; to be used for passing the /RegenAll
Local $sCmd1 = ""
If $CmdLine[0] Then $sCmd1 = $CmdLine[1]

_OutputBuildWrite("Generate HTM files for all changed Methods" & @CRLF)
RunWait('"' & @AutoItExe & '"' & ' ..\..\_build\include\Gen_txt2htm.au3 ' & $sCmd1)

_OutputBuildWrite("Generate Reference HTM files for Methods" & @CRLF)
RunWait('"' & @AutoItExe & '"' & ' ..\..\_build\include\Gen_RefPages.au3')

_OutputBuildWrite("Creating the index entries for all builtin methods" & @CRLF)
Main()

_OutputBuildWrite("Generate Management HTM files for AutoItX" & @CRLF)
RunWait('"' & @AutoItExe & '"' & ' ..\..\_build\include\Gen_MgtPages.au3')

Exit

Func OnQuit()
	_OutputWaitClosed() ; ### when run in standalone
EndFunc   ;==>OnQuit

Func Main()
	Local $hFI_TOC_HND = FileOpen("AutoItX TOC.hhc", 0)
	Local $hFO_INDEX_HND = FileOpen("AutoItX Index.hhk", 2)
	; Check if file opened for reading OK
	If $hFI_TOC_HND = -1 Then
		MsgBox(0, "Error", "Unable to open file.")
		Exit
	EndIf
	; start
	FileWriteLine($hFO_INDEX_HND, '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">')
	FileWriteLine($hFO_INDEX_HND, '<HTML>')
	FileWriteLine($hFO_INDEX_HND, '<HEAD>' & @LF)
	FileWriteLine($hFO_INDEX_HND, '<meta name="GENERATOR" content="Microsoft&reg; HTML Help Workshop 4.1">')
	FileWriteLine($hFO_INDEX_HND, '<!-- Sitemap 1.0 -->')
	FileWriteLine($hFO_INDEX_HND, '</HEAD><BODY>')
	FileWriteLine($hFO_INDEX_HND, '<UL>')
	; jump to last record processed
	Local $sLINE = ""
	Local $sNAME = ""
	Local $iMACROSECTION, $sTNAME, $sFN, $hFI_TOC_HNDI, $sLINEI
	While 1
		$sLINE = FileReadLine($hFI_TOC_HND)
		If @error = -1 Then
			ExitLoop
		EndIf
		Select
			Case StringInStr(StringLower($sLINE), '<li>') > 0
				$sNAME = ""
			Case StringInStr(StringLower($sLINE), '<param name="name"') > 0
				$sNAME = StringReplace($sLINE, Chr(09), "")
				If StringInStr($sLINE, ' Macros"') > 0 Then
					$iMACROSECTION = 1
				Else
					$iMACROSECTION = 0
				EndIf
			Case StringInStr(StringLower($sLINE), '<param name="local"') > 0
				FileWriteLine($hFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
				FileWriteLine($hFO_INDEX_HND, '   ' & $sNAME)
				FileWriteLine($hFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
				FileWriteLine($hFO_INDEX_HND, '		</OBJECT>')
				; create entries in index for #include as include
				If StringInStr($sNAME, 'value="#') > 0 And StringInStr($sNAME, '...') = 0 Then
					FileWriteLine($hFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
					FileWriteLine($hFO_INDEX_HND, '   ' & StringReplace($sNAME, "#", ""))
					FileWriteLine($hFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
					FileWriteLine($hFO_INDEX_HND, '		</OBJECT>')
				EndIf
				; gen entry in index for each keyword on a line like If...Else...EndIf
				If StringInStr($sNAME, "...") > 0 Then
					While StringInStr($sNAME, "...") > 0
						$sTNAME = StringLeft($sNAME, StringInStr($sNAME, "...") - 1) & '">'
						$sNAME = StringLeft($sNAME, StringInStr($sNAME, 'value="') + 6) & StringTrimLeft($sNAME, StringInStr($sNAME, "...") + 2)
						FileWriteLine($hFO_INDEX_HND, '	<LI> <OBJECT type="text/sitemap">')
						FileWriteLine($hFO_INDEX_HND, '   ' & $sTNAME)
						FileWriteLine($hFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
						FileWriteLine($hFO_INDEX_HND, '		</OBJECT>')
						; create entries in index for #include as include
						If StringInStr($sTNAME, 'value="#') > 0 Then
							FileWriteLine($hFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
							FileWriteLine($hFO_INDEX_HND, '   ' & StringReplace($sTNAME, "#", ""))
							FileWriteLine($hFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
							FileWriteLine($hFO_INDEX_HND, '		</OBJECT>')
						EndIf
					WEnd
					FileWriteLine($hFO_INDEX_HND, '	<LI> <OBJECT type="text/sitemap">')
					FileWriteLine($hFO_INDEX_HND, '   ' & $sNAME)
					FileWriteLine($hFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
					FileWriteLine($hFO_INDEX_HND, '		</OBJECT>')
					; create entries in index for #include as include
					If StringInStr($sNAME, 'value="#') > 0 Then
						FileWriteLine($hFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
						FileWriteLine($hFO_INDEX_HND, '   ' & StringReplace($sNAME, "#", ""))
						FileWriteLine($hFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
						FileWriteLine($hFO_INDEX_HND, '		</OBJECT>')
					EndIf
				EndIf
				; Skip link to sub-sections for the Project file
				If StringInStr($sLINE, "#") = 0 Then
					$sFN = StringTrimRight(StringTrimLeft($sLINE, StringInStr(StringLower($sLINE), 'value="') + 6), 2)
					; Read the HTM file for all @ MAcros and generate index entry for them
					If $iMACROSECTION = 1 Then
						; open the HTM file for Input
						$hFI_TOC_HNDI = FileOpen($sFN, 0)
						If $hFI_TOC_HNDI = -1 Then
							MsgBox(0, "Error", "Unable to open: " & $sFN)
						EndIf
						While 1
							$sLINEI = FileReadLine($hFI_TOC_HNDI)
							If @error = -1 Then
								ExitLoop
							EndIf
							; Check for '>@' or '> @'
							If StringInStr(StringStripWS($sLINEI, 7), '>@') > 0 Or StringInStr(StringStripWS($sLINEI, 7), '> @') > 0 Then
								$sNAME = StringTrimLeft($sLINEI, StringInStr($sLINEI, '@') - 1)
								$sNAME = StringReplace($sNAME, "<br>", "")
								$sNAME = StringReplace($sNAME, "</td>", "")
								$sNAME = StringReplace($sNAME, "</span>", "")
								; MsgBox(0,$sNAME,$sNAME)
								FileWriteLine($hFO_INDEX_HND, '	<LI> <OBJECT type="text/sitemap">')
								FileWriteLine($hFO_INDEX_HND, '   <param name="Name" value="' & $sNAME & '">')
								FileWriteLine($hFO_INDEX_HND, '   <param name="Local" value="' & $sFN & '">')
								FileWriteLine($hFO_INDEX_HND, '		</OBJECT>')
							EndIf
						WEnd
						FileClose($hFI_TOC_HNDI)
					EndIf
				EndIf
		EndSelect
	WEnd
	;end
	FileWriteLine($hFO_INDEX_HND, '</UL>')
	FileWriteLine($hFO_INDEX_HND, '</BODY></HTML>')
	;
	FileClose($hFI_TOC_HND)
	FileClose($hFO_INDEX_HND)
EndFunc   ;==>Main
